/*-----------------------------------------------
-----------------------------------------------*/
#include <reg251sb.h>

#define DELAY   10000

/*-----------------------------------------------
-----------------------------------------------*/
void write_pattern (
  unsigned char far *buf,
  unsigned long buf_len,
  unsigned char far *ptrn,
  unsigned char ptrn_len)
{
unsigned long i;
unsigned char ptrn_ndx;

for (ptrn_ndx = i = 0; i < buf_len; i++, ptrn_ndx++)
  {
  if (ptrn_ndx >= ptrn_len)
    ptrn_ndx = 0;

  buf [i] = ptrn [ptrn_ndx];
  }
}

/*-----------------------------------------------
-----------------------------------------------*/
unsigned long verify_pattern (
  unsigned char far *buf,
  unsigned long buf_len,
  unsigned char far *ptrn,
  unsigned char ptrn_len)
{
unsigned long i;
unsigned char ptrn_ndx;

for (ptrn_ndx = i = 0; i < buf_len; i++, ptrn_ndx++)
  {
  if (ptrn_ndx >= ptrn_len)
    ptrn_ndx = 0;

  if (buf [i] != ptrn [ptrn_ndx])
    return (i);
  }

return (0xFFFFFFFF);
}

/*-----------------------------------------------
-----------------------------------------------*/
void main (void)
{
static unsigned char far test_str [] = "This is a test string.  XXXX 123.";
unsigned long i;

for (;;)
  {
  P1 = 0xAA;
  write_pattern (0x00FE0000, 0x00010000, test_str, sizeof (test_str) - 1);

  P1 = 0x00;
  if (verify_pattern (0x00FE0000, 0x00010000, test_str, sizeof (test_str) - 1) ==0xFFFFFFFF)
    {
    P1 = 0x0F;
    }
  else
    {
    P1 = 0x55;
    for (i = 0; i < DELAY; i++);
    P1 = 0;
    for (i = 0; i < DELAY; i++);
    P1 = 0x55;
    for (i = 0; i < DELAY; i++);
    P1 = 0;
    for (i = 0; i < DELAY; i++);
    P1 = 0x55;
    for (i = 0; i < DELAY; i++);
    P1 = 0;
    for (i = 0; i < DELAY; i++);
    P1 = 0x55;
    for (i = 0; i < DELAY; i++);
    P1 = 0;
    for (i = 0; i < DELAY; i++);
    P1 = 0x55;
    for (i = 0; i < DELAY; i++);
    P1 = 0;
    }

  for (i = 0; i < DELAY; i++);
  for (i = 0; i < DELAY; i++);
  for (i = 0; i < DELAY; i++);
  for (i = 0; i < DELAY; i++);
  for (i = 0; i < DELAY; i++);
  for (i = 0; i < DELAY; i++);
  for (i = 0; i < DELAY; i++);
  for (i = 0; i < DELAY; i++);
  for (i = 0; i < DELAY; i++);
  }
}

/*-----------------------------------------------
-----------------------------------------------*/

